//= require jquery/jquery.js
//= require jquery-validation/jquery.validate.js
//= require pickadate/picker.js
//= require pickadate/picker.date.js
//= require bootstrap/bootstrap.js

(function($) {
  var isCheckbox = function(e) {
    if (e.is(':checkbox')) return true;

    var name = e.attr('name');
    return (e.siblings(':checkbox').attr('name') === name);
  };

  $.validator.setDefaults({
    "ignore": '.picker__input',
    "highlight": function(element) {
        $(element).closest('.form-group').addClass('has-error');
      },
    "unhighlight": function(element) {
      $(element).closest('.form-group').removeClass('has-error');
    },
    "errorElement": 'span',
    "errorClass": 'help-block',
    "errorPlacement": function(error, element) {
      if (element.is(':radio')) {
        error.appendTo(element.parents('.form-group.has-error'));
      } else if (isCheckbox(element)) {
        error.insertAfter(element.parent('label'));
      } else {
        error.insertAfter(element);
      }
    }
  });

  $.extend($.fn.pickadate.defaults, {
    "format": 'dd/mm/yyyy',
    "formatSubmit": 'yyyy-mm-dd',
    "hiddenName": true
  });
})(jQuery);

jQuery(function($) {
  $('.date-picker').pickadate().each(function() {
    var e = $(this).pickadate('picker');
    var val = $(this).val();
    if (val) e.set('select', val, { format: 'yyyy-mm-dd' });
  });

  if ($('script.lipstick-validations').length) {
    $('script.lipstick-validations').each(function() {
      var target = $(this).data('target');
      var json = this.innerHTML;
      $(target).validate($.parseJSON(json));
    });
  }

  $('main').on('click', '.confirm-delete', function(event) {
    event.preventDefault();

    var csrf_param = $('meta[name="csrf-param"]').attr('content');
    var csrf_token = $('meta[name="csrf-token"]').attr('content');

    var form = $('<form></form>',
      {
        "method": 'POST',
        "action": $(this).prop('href')
      }
    );

    var hidden = $('<input>',
      {
        "type": 'hidden',
        "name": '_method',
        "value": 'DELETE'
      }
    );

    var csrf_field = $('<input>',
      {
        "type": 'hidden',
        "name": csrf_param,
        "value": csrf_token
      }
    );

    form.hide().append(hidden).append(csrf_field).appendTo(document.body);
    form.submit();
  });
});
