# frozen_string_literal: true

module Lipstick
  module Helpers
    module NavHelper
      def nav_bar(&block)
        content_tag('nav', class: 'navbar shrink', &block)
      end

      def nav_first_item(text, url)
        content_tag('div', class: 'nav navbar-header') do
          concat(nav_collapse_button)
          concat(content_tag('a', text, href: url, class: 'navbar-brand'))
        end
      end

      def nav_collapsing_items(&block)
        attrs = { class: 'collapse navbar-collapse', id: 'aaf-nav-collapse' }
        content_tag('div', attrs) do
          content_tag('ul', class: 'nav navbar-nav', &block)
        end
      end

      def nav_item(text, url, html_opts = {})
        content_tag('li') do
          content_tag('a', text, html_opts.merge(href: url))
        end
      end

      private

      def nav_collapse_button
        attrs = {
          type: 'button', class: 'navbar-toggle collapsed',
          'data-toggle': 'collapse', 'data-target': '#aaf-nav-collapse',
          'aria-expanded': 'false'
        }

        content_tag('button', attrs) do
          concat(content_tag('span', 'Toggle navigation', class: 'sr-only'))
          3.times { concat(content_tag('span', '', class: 'icon-bar')) }
        end
      end
    end
  end
end
